<?php if (!defined('PmWiki')) exit();
# vim: set ts=4 sw=4 et:
##
##        File: multicolumn.php
##     Version: 2010-12-16B
##      Status: alpha
##      Author: Peter Bowers
## Create Date: December 16, 2010
##   Copyright: 2010-2011, Peter Bowers
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License, Version 2, as
## published by the Free Software Foundation.
## http://www.gnu.org/copyleft/gpl.html
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

$RecipeInfo['MultiColumn']['Version'] = '2010-12-16B';

Markup('multicolumn', '<split', '/\\(:STARTCOLUMNS?(.*?):\\)(.*?)\\(:ENDCOLUMNS?(.*?):\\)/sie', "MultiColumn('$pagename', PSS('$1'), PSS('$2'), PSS('$3'))");

function MultiColumn($pagename, $args, $text, $endargs)
{
	global $HTMLHeaderFmt, $PubDirUrl;
	$opts = ParseArgs($args);
	static $Containers = array(); // hold names of containers
	static $Count = 0; // hold count of containers
	for($i=sizeof($Containers), $newname = 'container'.$i; in_array($newname, $Containers); $i++); // loop until unused name
	if (!$Count) {
		$HTMLHeaderFmt[] = <<<EOHEREDOC
<style type="text/css">
/*Initial definitions for base column. 
Define the (minimum) width here, and optionally a padding */
.columnized div {
float: left;
width: 18em;		/* When using a fixed number of columns, you can omit the width. Otherwise it must be set! This will be the *minimum* width of a column*/
padding: 10px;		/* You may use a padding... but thanks to IE you can only use pixels! */
position: relative; 		/* Needed when using a 'read-on'-text */
text-align: justify;
margin: 0;	 		/* Don't use a margin! */
}
					
/* Optional 'read on'-message. Not used in this example. */
.columnized div .readOn {
position: absolute;
right: 1em;
bottom: -0.5em;
color: #999999;
}
</style>
<script type="text/javascript">
var multiColumnSettings = [];
window.onload = function () {
	for (i=0; i<multiColumnSettings.length; i++)
		new MultiColumn(document.getElementById(multiColumnSettings[i].name),multiColumnSettings[i]);
		//new MultiColumn(document.getElementById("$newname"),multiColumnSettings[i]);
}
</script>
<script type="text/javascript" src="$PubDirUrl/multicolumn/multicolumn.js"></script>
EOHEREDOC;
	} // end if(!$Count)		
	$Containers[$Count] = $newname;
	$Settings = <<<EOHEREDOC2
<script type="text/javascript">	
multiColumnSettings[$Count]=new MultiColumnSettings;
multiColumnSettings[$Count].name='$newname';
multiColumnSettings[$Count].classNameScreen='columnized';
EOHEREDOC2;
	if ($opts['minheight'])
		$Settings .= "\nmultiColumnSettings[$Count].minHeight=$opts[minheight];";
	if ($opts['minsplitheight'])
		$Settings .= "\nmultiColumnSettings[$Count].minSplitHeight=$opts[minsplitheight];";
	if ($opts['extraheight'])
		$Settings .= "\nmultiColumnSettings[$Count].extraHeight=$opts[extraheight];";
	if ($opts['columns'])
		$Settings .= "\nmultiColumnSettings[$Count].numberOfColumns=$opts[columns];";
	if ($opts['readontext'])
		$Settings .= "\nmultiColumnSettings[$Count].readOnText='".htmlspecialchars_decode($opts[readontext])."';";
	$Settings .= "\n</script>\n\n";
	$HTMLHeaderFmt[] = $Settings;
	$Count++;
	#echo "NAME: $newname<br>\n";
	#$HTMLHeaderFmt[] = "<br>\nTHIS IS A TEST<br>\n";
	return <<<EOHEREDOC3
<div id="$newname">
<div>
$text
</div>
</div>
EOHEREDOC3
;
}
